de.esprit.appsuite.appstore.ndf

## Class App

- java.lang.Object
- - de.esprit.common.util.DumpableObject
  - - de.esprit.appsuite.appstore.ndf.App

- All Implemented Interfaces:
    Dumpable

      public final class App
      extends DumpableObject

  This class describes an application that can be downloaded from a web-server by the `AppCacheManager`. It defines the application-name and contains a list of the available `AppVersion` instances.
  Author:
    Rainer Buesch

- - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `static java.lang.String` | `appsFileName`
    `static java.lang.String` | `columnAppDir`
    `static java.lang.String` | `columnAppDisplayName`
    `static java.lang.String` | `columnAppInfo`
    `static java.lang.String` | `docTypeApps`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `App(java.lang.String appDirName, java.lang.String appDisplayName, java.lang.String appInfo)`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `addVersion(AppVersion version)`
    `AppVersion` | `findVersion(java.lang.String versionDirName)` Returns the desiredVersion if it was found, otherwise the version which is defined to be the current one.
    `java.lang.String` | `getAppDirName()`
    `java.lang.String` | `getAppDisplayName()`
    `java.lang.String` | `getAppInfo()`
    `java.util.List<AppVersion>` | `getAppVersions()`
    `AppVersion` | `getCurrentVersion()`
    `java.util.Set<java.lang.String>` | `getCustomPropertyNames()`
    `boolean` | `isCustomPropertyRequired(java.lang.String propertyName)`
    `void` | `putCustomPropertyDef(java.lang.String propertyName, boolean isRequired)`
    `static void` | `readApps(ApplicationContext ctx, java.io.File baseDir, java.util.List<App> appList)`
    `DumpString` | `toDumpString(DumpString s)` This method allows subclasses to add values to the existing DumpString of the superclass.
    `ToString` | `toString(ToString s)` This method allows subclasses to add values to the existing ToString of the superclass.

    - ### Methods inherited from class de.esprit.common.util.DumpableObject

      `configureDumpHeadlineLength, configureDumpMaxElementsPrinted, copyDumpStringValues, copyToStringValues, createDumpHeader, toDumpString, toString`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, wait, wait, wait`

- - ### Field Detail

    - #### docTypeApps

          public static final java.lang.String docTypeApps

      See Also:
        Constant Field Values

    - #### appsFileName

          public static final java.lang.String appsFileName

      See Also:
        Constant Field Values

    - #### columnAppDir

          public static final java.lang.String columnAppDir

      See Also:
        Constant Field Values

    - #### columnAppDisplayName

          public static final java.lang.String columnAppDisplayName

      See Also:
        Constant Field Values

    - #### columnAppInfo

          public static final java.lang.String columnAppInfo

      See Also:
        Constant Field Values

  - ### Constructor Detail

    - #### App

          public App(java.lang.String appDirName,
             java.lang.String appDisplayName,
             java.lang.String appInfo)

  - ### Method Detail

    - #### getAppDirName

          public java.lang.String getAppDirName()

    - #### getAppDisplayName

          public java.lang.String getAppDisplayName()

    - #### getAppInfo

          public java.lang.String getAppInfo()

    - #### addVersion

          public void addVersion(AppVersion version)

    - #### getAppVersions

          public java.util.List<AppVersion> getAppVersions()

    - #### findVersion

          public AppVersion findVersion(java.lang.String versionDirName)
                                 throws MissingCurrentVersionException

      Returns the desiredVersion if it was found, otherwise the version which is defined to be the current one.
      Throws:
        `MissingCurrentVersionException`

    - #### getCurrentVersion

          public AppVersion getCurrentVersion()
                                       throws MissingCurrentVersionException

      Throws:
        `MissingCurrentVersionException`

    - #### getCustomPropertyNames

          public java.util.Set<java.lang.String> getCustomPropertyNames()

    - #### isCustomPropertyRequired

          public boolean isCustomPropertyRequired(java.lang.String propertyName)

    - #### putCustomPropertyDef

          public void putCustomPropertyDef(java.lang.String propertyName,
                                  boolean isRequired)

    - #### toString

          public ToString toString(ToString s)

      Description copied from interface: `Dumpable`
      This method allows subclasses to add values to the existing ToString of the superclass. Usually subclasses only need to override this method.
      Specified by:
        `toString` in interface `Dumpable`
      Overrides:
        `toString` in class `DumpableObject`

    - #### toDumpString

          public DumpString toDumpString(DumpString s)

      Description copied from interface: `Dumpable`
      This method allows subclasses to add values to the existing DumpString of the superclass. Usually subclasses only need to override this method.
      Specified by:
        `toDumpString` in interface `Dumpable`
      Overrides:
        `toDumpString` in class `DumpableObject`

    - #### readApps

          public static void readApps(ApplicationContext ctx,
                      java.io.File baseDir,
                      java.util.List<App> appList)
                               throws java.lang.Exception

      Throws:
        `java.lang.Exception`

Copyright © 2014 EsprIT-Systems. All Rights Reserved.